/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */

/**
 * TODO Beschreibung
 * 
 * @author inovat
 * @author Dipl.-Ing. Hans Chrstian Kni (HCK)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

/**
 * TODO Wichtige Quellen
 * http://jaxb.dev.java.net
 * http://java.sun.com/xml/jaxb/index.jsp
 * http://java.sun.com/webservices/jwsdp/index.jsp
 */

/**
 * TODO Weitere Java Objektstrukturen
 * attribute.txt, objekte.txt, objektstruktur.txt
 */

package de.inovat.sys.funclib.bsvrzxml;

import de.inovat.pat.datkat2html.Activator;
import de.inovat.pat.datkat2html.Log;
import de.inovat.pat.datkat2html.html.KonvertierungsProzessAenderungen.MeldungsTyp;
import de.inovat.sys.funclib.bsvrzxml.binder.*;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FilterWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.StringWriter;
import java.io.Writer;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.validation.SchemaFactory;

import org.eclipse.core.runtime.FileLocator;
import org.xml.sax.SAXException;

/**
 * TODO Beschreibung
 * 
 * <p>Die Klasse <code>BSVRZXML</code></p>
 * 
 * @author inovat
 * @author HCK
 * @author DD
 */
public class
		BSVRZXML {
	
	// TODO berprfen: PID mehrmals in einem KB.

	/*
	private Map<String, Abbildung> mapAbbildung = new HashMap<String, Abbildung>();
	private Map<String, Abbildungsverzeichnis> mapAbbildungsverzeichnis = new HashMap<String, Abbildungsverzeichnis>();
	private Map<String, AbgedeckteAnforderung> mapAbgedeckteAnforderung = new HashMap<String, AbgedeckteAnforderung>();
    private Map<String, Absatz> mapAbsatz = new HashMap<String, Absatz>();
	private Map<String, Adresse> mapAdresse = new HashMap<String, Adresse>();
	private Map<String, Aenderung> mapAenderung = new HashMap<String, Aenderung>();
	private Map<String, Aenderungsuebersicht> mapAenderungsuebersicht = new HashMap<String, Aenderungsuebersicht>();
	private Map<String, Anforderung> mapAnforderung = new HashMap<String, Anforderung>();
	private Map<String, Anforderungen> mapAnforderungen = new HashMap<String, Anforderungen>();
	private Map<String, Anforderungsverzeichnis> mapAnforderungsverzeichnis = new HashMap<String, Anforderungsverzeichnis>();
	private Map<String, Anker> mapAnker = new HashMap<String, Anker>();
	private Map<String, AnkerTag> mapAnkerTag = new HashMap<String, AnkerTag>();
	private Map<String, ArchitekturSegment> mapArchitekturSegment = new HashMap<String, ArchitekturSegment>();
	private Map<String, ArchitekturSwEinheit> mapArchitekturSwEinheit = new HashMap<String, ArchitekturSwEinheit>();
	private Map<String, ArchitekturSwEinheitIntern> mapArchitekturSwEinheitIntern = new HashMap<String, ArchitekturSwEinheitIntern>();
	private Map<String, ArchitekturSwEinheitInterneWurzel> mapArchitekturSwEinheitInterneWurzel = new HashMap<String, ArchitekturSwEinheitInterneWurzel>();
	private Map<String, ArchitekturSwKomponente> mapArchitekturSwKomponente = new HashMap<String, ArchitekturSwKomponente>();
	private Map<String, ArchitekturSwModul> mapArchitekturSwModul = new HashMap<String, ArchitekturSwModul>();
	private Map<String, ArchitekturSwWiederverwendung> mapArchitekturSwWiederverwendung = new HashMap<String, ArchitekturSwWiederverwendung>();
	private Map<String, ArchitekturSystem> mapArchitekturSystem = new HashMap<String, ArchitekturSystem>();
	*/
	private Map<String, Aspekt> mapAspekt = new HashMap<String, Aspekt>();
	private Map<String, AspektDefinition> mapAspektDefinition = new HashMap<String, AspektDefinition>();
	private Map<String, Attribut> mapAttribut = new HashMap<String, Attribut>();
	private Map<String, Attributauswahl> mapAttributauswahl = new HashMap<String, Attributauswahl>();
	private Map<String, AttributauswahlDefinition> mapAttributauswahlDefinition = new HashMap<String, AttributauswahlDefinition>();
	private Map<String, AttributDefinition> mapAttributDefinition = new HashMap<String, AttributDefinition>();
	private Map<String, Attributgruppe> mapAttributgruppe = new HashMap<String, Attributgruppe>();
	private Map<String, AttributgruppenDefinition> mapAttributgruppenDefinition = new HashMap<String, AttributgruppenDefinition>();
	private Map<String, Attributliste> mapAttributliste = new HashMap<String, Attributliste>();
	private Map<String, AttributlistenDefinition> mapAttributlistenDefinition = new HashMap<String, AttributlistenDefinition>();
	/*
	private Map<String, AufrufParameter> mapAufrufParameter = new HashMap<String, AufrufParameter>();
	private Map<String, AufrufParameterReferenz> mapAufrufParameterReferenz = new HashMap<String, AufrufParameterReferenz>();
	private Map<String, Ausgang> mapAusgang = new HashMap<String, Ausgang>();
	private Map<String, AusgangsDaten> mapAusgangsDaten = new HashMap<String, AusgangsDaten>();
	private Map<String, Ausnahme> mapAusnahme = new HashMap<String, Ausnahme>();
	*/
	private Map<String, Auswahl> mapAuswahl = new HashMap<String, Auswahl>();
	/*
	private Map<String, Autor> mapAutor = new HashMap<String, Autor>();
	private Map<String, Basis> mapBasis = new HashMap<String, Basis>();
	private Map<String, Benutzer> mapBenutzer = new HashMap<String, Benutzer>();
	private Map<String, Bereich> mapBereich = new HashMap<String, Bereich>();
	private Map<String, Beschreibung> mapBeschreibung = new HashMap<String, Beschreibung>();
	private Map<String, BeteiligteElemente> mapBeteiligteElemente = new HashMap<String, BeteiligteElemente>();
	private Map<String, Bit> mapBit = new HashMap<String, Bit>();
	private Map<String, Code> mapCode = new HashMap<String, Code>();
	private Map<String, DateiSchnittstelle> mapDateiSchnittstelle = new HashMap<String, DateiSchnittstelle>();
	private Map<String, Datenfeld> mapDatenfeld = new HashMap<String, Datenfeld>();
	private Map<String, Datenfluss> mapDatenfluss = new HashMap<String, Datenfluss>();
	private Map<String, Datenkatalog> mapDatenkatalog = new HashMap<String, Datenkatalog>();
	private Map<String, Datenliste> mapDatenliste = new HashMap<String, Datenliste>();
	*/
	private Map<String, Datensatz> mapDatensatz = new HashMap<String, Datensatz>();
	private Map<String, String> mapDatensatzAtg = new HashMap<String, String>();
	private Map<String, String> mapDatensatzAspekt = new HashMap<String, String>();
	/*
	private Map<String, Datum> mapDatum = new HashMap<String, Datum>();
	private Map<String, Default> mapDefault = new HashMap<String, Default>();
	private Map<String, DokTitel> mapDokTitel = new HashMap<String, DokTitel>();
	private Map<String, Dokument> mapDokument = new HashMap<String, Dokument>();
	private Map<String, Eingang> mapEingang = new HashMap<String, Eingang>();
	private Map<String, EingangsDaten> mapEingangsDaten = new HashMap<String, EingangsDaten>();
	 */
	private Map<String, Element> mapElement = new HashMap<String, Element>();
	//private Map<String, Ersteller> mapErsteller = new HashMap<String, Ersteller>();
	private Map<String, Erweitert> mapErweitert = new HashMap<String, Erweitert>();
	/*
	private Map<String, Extern> mapExtern = new HashMap<String, Extern>();
	private Map<String, ExterneSchnittstelle> mapExterneSchnittstelle = new HashMap<String, ExterneSchnittstelle>();
	private Map<String, Feld> mapFeld = new HashMap<String, Feld>();
	private Map<String, Feldtyp> mapFeldtyp = new HashMap<String, Feldtyp>();
	private Map<String, FuerObjekte> mapFuerObjekte = new HashMap<String, FuerObjekte>();
	private Map<String, FunktionsSchnittstelle> mapFunktionsSchnittstelle = new HashMap<String, FunktionsSchnittstelle>();
	private Map<String, Ganzzahl> mapGanzzahl = new HashMap<String, Ganzzahl>();
	private Map<String, GeaendertesKapitel> mapGeaendertesKapitel = new HashMap<String, GeaendertesKapitel>();
	private Map<String, Global> mapGlobal = new HashMap<String, Global>();
	private Map<String, Grund> mapGrund = new HashMap<String, Grund>();
	private Map<String, Hinweis> mapHinweis = new HashMap<String, Hinweis>();
	private Map<String, Historie> mapHistorie = new HashMap<String, Historie>();
	private Map<String, Hoch> mapHoch = new HashMap<String, Hoch>();
	private Map<String, IdentifikationExterneSchnittstelle> mapIdentifikationExterneSchnittstelle = new HashMap<String, IdentifikationExterneSchnittstelle>();
	private Map<String, IdentifikationInterneSchnittstelle> mapIdentifikationInterneSchnittstelle = new HashMap<String, IdentifikationInterneSchnittstelle>();
	private Map<String, ImAuftrag> mapImAuftrag = new HashMap<String, ImAuftrag>();
	private Map<String, Include> mapInclude = new HashMap<String, Include>();
	private Map<String, Index> mapIndex = new HashMap<String, Index>();
	private Map<String, Indexverzeichnis> mapIndexverzeichnis = new HashMap<String, Indexverzeichnis>();
	private Map<String, Info> mapInfo = new HashMap<String, Info>();
	private Map<String, Inhaltsverzeichnis> mapInhaltsverzeichnis = new HashMap<String, Inhaltsverzeichnis>();
	private Map<String, Kapitel> mapKapitel = new HashMap<String, Kapitel>();
	private Map<String, Klasse> mapKlasse = new HashMap<String, Klasse>();
	private Map<String, Kommazahl> mapKommazahl = new HashMap<String, Kommazahl>();
	private Map<String, Kommentar> mapKommentar = new HashMap<String, Kommentar>();
	private Map<String, KommunikationsSchnittstelle> mapKommunikationsSchnittstelle = new HashMap<String, KommunikationsSchnittstelle>();
	*/
	private Map<String, KonfigurationsBereich> mapKonfigurationsBereich = new HashMap<String, KonfigurationsBereich>();
	private Map<String, KonfigurationsBereiche> mapKonfigurationsBereiche = new HashMap<String, KonfigurationsBereiche>();
	private Map<String, KonfigurationsDaten> mapKonfigurationsDaten = new HashMap<String, KonfigurationsDaten>();
	private Map<String, KonfigurationsObjekt> mapKonfigurationsObjekt = new HashMap<String, KonfigurationsObjekt>();
	private Map<String, String> mapKonfigurationsObjektDefParTyp = new HashMap<String, String>();
	private Map<String, String> mapKonfigurationsObjektDefParAtg = new HashMap<String, String>();
	private Map<String, String> mapKonfigurationsObjektTyp = new HashMap<String, String>();
	/*
	private Map<String, Konstruktor> mapKonstruktor = new HashMap<String, Konstruktor>();
	private Map<String, Kopf> mapKopf = new HashMap<String, Kopf>();
	private Map<String, KritikalitaetsUebersicht> mapKritikalitaetsUebersicht = new HashMap<String, KritikalitaetsUebersicht>();
	private Map<String, Kurzinfo> mapKurzinfo = new HashMap<String, Kurzinfo>();
	private Map<String, Liste> mapListe = new HashMap<String, Liste>();
	private Map<String, ListenPunkt> mapListenPunkt = new HashMap<String, ListenPunkt>();
	private Map<String, Listing> mapListing = new HashMap<String, Listing>();
	private Map<String, LogischeSchnittstelle> mapLogischeSchnittstelle = new HashMap<String, LogischeSchnittstelle>();
	private Map<String, Los> mapLos = new HashMap<String, Los>();
	*/
	private Map<String, Menge> mapMenge = new HashMap<String, Menge>();
	private Map<String, MengenDefinition> mapMengenDefinition = new HashMap<String, MengenDefinition>();
	private Map<String, String> mapMengenElemente = new HashMap<String, String>();
	private Map<String, Methode> mapMethode = new HashMap<String, Methode>();
	private Map<String, Modell> mapModell = new HashMap<String, Modell>();
	/*
	private Map<String, NumListe> mapNumListe = new HashMap<String, NumListe>();
	private Map<String, NutzerSchnittstelle> mapNutzerSchnittstelle = new HashMap<String, NutzerSchnittstelle>();
	private Map<String, ObjectFactory> mapObjectFactory = new HashMap<String, ObjectFactory>();
	*/
	private Map<String, Objekte> mapObjekte = new HashMap<String, Objekte>();
	private Map<String, ObjektMenge> mapObjektMenge = new HashMap<String, ObjektMenge>();
	private Map<String, ObjektReferenz> mapObjektReferenz = new HashMap<String, ObjektReferenz>();
	/*
	private Map<String, Parameter> mapParameter = new HashMap<String, Parameter>();
	private Map<String, Pid> mapPid = new HashMap<String, Pid>();
	private Map<String, Pre> mapPre = new HashMap<String, Pre>();
	private Map<String, PrimitiverTyp> mapPrimitiverTyp = new HashMap<String, PrimitiverTyp>();
	private Map<String, PrimitiveTypenAusgabe> mapPrimitiveTypenAusgabe = new HashMap<String, PrimitiveTypenAusgabe>();
	private Map<String, Programmiersprache> mapProgrammiersprache = new HashMap<String, Programmiersprache>();
	private Map<String, Projekt> mapProjekt = new HashMap<String, Projekt>();
	private Map<String, ProjektIdAG> mapProjektIdAG = new HashMap<String, ProjektIdAG>();
	private Map<String, ProjektIdAN> mapProjektIdAN = new HashMap<String, ProjektIdAN>();
	private Map<String, Prozess> mapProzess = new HashMap<String, Prozess>();
	private Map<String, Referenz> mapReferenz = new HashMap<String, Referenz>();
	private Map<String, Referenzen> mapReferenzen = new HashMap<String, Referenzen>();
	private Map<String, ReferenzenAuf> mapReferenzenAuf = new HashMap<String, ReferenzenAuf>();
	private Map<String, Referenzverzeichnis> mapReferenzverzeichnis = new HashMap<String, Referenzverzeichnis>();
	private Map<String, Rueckgabe> mapRueckgabe = new HashMap<String, Rueckgabe>();
	private Map<String, Rumpf> mapRumpf = new HashMap<String, Rumpf>();
	private Map<String, Schluesselwort> mapSchluesselwort = new HashMap<String, Schluesselwort>();
	private Map<String, Schnittstelle> mapSchnittstelle = new HashMap<String, Schnittstelle>();
	private Map<String, Schnittstellen> mapSchnittstellen = new HashMap<String, Schnittstellen>();
	private Map<String, SchnittstellenKlasse> mapSchnittstellenKlasse = new HashMap<String, SchnittstellenKlasse>();
	private Map<String, SchnittstellenUebersicht> mapSchnittstellenUebersicht = new HashMap<String, SchnittstellenUebersicht>();
	private Map<String, SchnittstellenUebersichtExtern> mapSchnittstellenUebersichtExtern = new HashMap<String, SchnittstellenUebersichtExtern>();
	private Map<String, SchnittstellenUebersichtIntern> mapSchnittstellenUebersichtIntern = new HashMap<String, SchnittstellenUebersichtIntern>();
	private Map<String, Sektion> mapSektion = new HashMap<String, Sektion>();
	private Map<String, SonstigeSchnittstelle> mapSonstigeSchnittstelle = new HashMap<String, SonstigeSchnittstelle>();
	private Map<String, Spalte> mapSpalte = new HashMap<String, Spalte>();
	private Map<String, Starter> mapStarter = new HashMap<String, Starter>();
	private Map<String, StarterSchnittstelle> mapStarterSchnittstelle = new HashMap<String, StarterSchnittstelle>();
	private Map<String, StartParameter> mapStartParameter = new HashMap<String, StartParameter>();
	private Map<String, Submodell> mapSubmodell = new HashMap<String, Submodell>();
	private Map<String, SwAnforderungszuordnung> mapSwAnforderungszuordnung = new HashMap<String, SwAnforderungszuordnung>();
	private Map<String, SwEinheitUebersicht> mapSwEinheitUebersicht = new HashMap<String, SwEinheitUebersicht>();
	private Map<String, SwElement> mapSwElement = new HashMap<String, SwElement>();
	private Map<String, SwExterneSchnittstellen> mapSwExterneSchnittstellen = new HashMap<String, SwExterneSchnittstellen>();
	private Map<String, SwInterneSchnittstellen> mapSwInterneSchnittstellen = new HashMap<String, SwInterneSchnittstellen>();
	private Map<String, SwModulEinzelbeschreibungen> mapSwModulEinzelbeschreibungen = new HashMap<String, SwModulEinzelbeschreibungen>();
	private Map<String, SwModulListe> mapSwModulListe = new HashMap<String, SwModulListe>();
	private Map<String, Szenario> mapSzenario = new HashMap<String, Szenario>();
	private Map<String, Tabelle> mapTabelle = new HashMap<String, Tabelle>();
	private Map<String, Tabellenverzeichnis> mapTabellenverzeichnis = new HashMap<String, Tabellenverzeichnis>();
	private Map<String, Telegramm> mapTelegramm = new HashMap<String, Telegramm>();
	private Map<String, TelegrammBlock> mapTelegrammBlock = new HashMap<String, TelegrammBlock>();
	private Map<String, TelegrammElement> mapTelegrammElement = new HashMap<String, TelegrammElement>();
	private Map<String, Tief> mapTief = new HashMap<String, Tief>();
	private Map<String, Titel> mapTitel = new HashMap<String, Titel>();
	*/
	private Map<String, TypApplikation> mapTypApplikation = new HashMap<String, TypApplikation>();
	private Map<String, TypDatenverteiler> mapTypDatenverteiler = new HashMap<String, TypDatenverteiler>();
	private Map<String, TypDefinition> mapTypDefinition = new HashMap<String, TypDefinition>();
	private Map<String, TypProgramm> mapTypProgramm = new HashMap<String, TypProgramm>();
	/*
	private Map<String, Variable> mapVariable = new HashMap<String, Variable>();
	private Map<String, Versionsuebersicht> mapVersionsuebersicht = new HashMap<String, Versionsuebersicht>();
	private Map<String, Verweis> mapVerweis = new HashMap<String, Verweis>();
	private Map<String, VSEinstufung> mapVSEinstufung = new HashMap<String, VSEinstufung>();
	private Map<String, Wichtig> mapWichtig = new HashMap<String, Wichtig>();
	private Map<String, Ze> mapZe = new HashMap<String, Ze>();
	private Map<String, Zeichenkette> mapZeichenkette = new HashMap<String, Zeichenkette>();
	private Map<String, Zeile> mapZeile = new HashMap<String, Zeile>();
	private Map<String, Zeitstempel> mapZeitstempel = new HashMap<String, Zeitstempel>();
	private Map<String, Zelle> mapZelle = new HashMap<String, Zelle>();
	private Map<String, Zitat> mapZitat = new HashMap<String, Zitat>();
	private Map<String, Zustand> mapZustand = new HashMap<String, Zustand>();
	*/
	private KonfigurationsBereich _kb;
	
	private String _inDateinameXML;
	private String _outDateinameXML;
	
	/**
	 * <p>Der Konstruktor <code>BSVRZXML</code></p> 
	 * Unmarshalling von XML-Dokumenten in eine Java-Objektstruktur<br>
	 * Erzeugung neuer Objekte fr diese Struktur<br>
	 * Marshalling einer Objektstruktur in ein XML-Dokument<br>
	 * @param inDateinameXML
	 * @throws FileNotFoundException
	 * @throws JAXBException
	 */
	public BSVRZXML (String inDateinameXML) throws FileNotFoundException, JAXBException {
		
		_inDateinameXML = inDateinameXML;
		
		/**
		 * <p>Die Methode <code>xmlEinlesen</code></p>
		 * @param inDateinameXML
		 * @throws Exception
		
		private void xmlEinlesen (String inDateinameXML) throws Exception {
			// System.out.format("--------------- JAXB (XML-Einlesen) inovat 2008 ---------------\n");
		}
		*/
		
		// Einstiegs- und Factory-Klasse
		JAXBContext jc = JAXBContext.newInstance("de.inovat.sys.funclib.bsvrzxml.binder");
		
		// Serialisieren und Parsen
		Unmarshaller unmarshaller = jc.createUnmarshaller();
		Marshaller marshaller = jc.createMarshaller();
	
		// -------
		// Schema-Datei und dtd-Datei fr die Validation
		// (liegen im Ordner mit dieser Klasse).
		// -------
		
		// Speichere den ArbeitsOrdner, wo die File gesucht werden:
		String arbeitsOrdner=System.getProperty("user.dir");
		// Erstelle den absoluten Pfad zum Ordner "de/inovat/sys/funclib/bsvrzxml":
		URL url=this.getClass().getClassLoader().getResource("de/inovat/sys/funclib/bsvrzxml");
		String pfadValidationDatei="";
		if (url!=null){
			try {
				pfadValidationDatei = FileLocator.toFileURL(url).getPath();
				if(pfadValidationDatei.contains("!")){
					pfadValidationDatei="jar:"+pfadValidationDatei;
				}
			} catch (IOException e) {
				Log.zeigeInterneMultiMeldung(Activator.PLUGIN_ID, "URL [" + url + "] kann nicht ermittelt werden!", e);
			}
		}
		else{
			Log.zeigeInterneMeldung(Activator.PLUGIN_ID, new Throwable("URL ["+url + "] ist leer."));
		}
		// Setzte neuen ArbeitsOrdner:
		System.setProperty("user.dir", pfadValidationDatei);
		// Setze Schema fr Unmarshaller:
		File fileXsd=new File("K2S.xsd");
		try {
			unmarshaller.setSchema(SchemaFactory.
					newInstance("http://www.w3.org/2001/XMLSchema").newSchema(fileXsd));
		} catch (SAXException e) {
			Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e);
		}
		
		// Validator validator = jc.createValidator();
		
		// ObjectFactory factory = new ObjectFactory();

		// Wert des encoding-Attributs in der XML-Deklaration
		// marshaller.setProperty(Marshaller.JAXB_ENCODING, Boolean.TRUE);
		
		// Die Ausgabe wird mit Linebreaks und Einrckungen formatiert
		marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

		// Wert des entsprechenden Attributs im Wurzelelement
		// marshaller.setProperty(Marshaller.JAXB_NO_NAMESPACE_SCHEMA_LOCATION, "K2S.xsd");
		
		// Wert des entsprechenden Attributs im Wurzelelement mit Namensraum
		marshaller.setProperty(Marshaller.JAXB_SCHEMA_LOCATION, "K2S.xsd");
		
		FileInputStream fileInput=new FileInputStream(inDateinameXML);
		_kb = (KonfigurationsBereich) unmarshaller.unmarshal(fileInput);
		
		try {
			fileInput.close();
		} catch (IOException e) {
			Log.zeigeInterneMeldung(Activator.PLUGIN_ID, e);
		}
		
		// Setzte den for der nderung gltigen Benutzerordner:
		System.setProperty("user.dir", arbeitsOrdner);


		// marshaller.marshal(kb, System.out);
		// marshaller.marshal(kb, new FileOutputStream("test/kb.ausgabe.xml"));
		
		/**
		 * <p>Die Methode <code>xmlZerlegen</code></p>
		 * @param inDateinameXML
		 * @throws Exception
		
		private void xmlZerlegen (String inDateinameXML) throws Exception {
			// System.out.format("--------------- JAXB (XML-Zerlegen) inovat 2008 ---------------\n");
		}
		*/
		
		// ANFANG Java Objektstruktur Anfang
		
		if (_kb.getModell()!= null && _kb.getModell().getTypDefinitionOrAttributgruppenDefinitionOrAspektDefinition() != null) {
			// System.out.println("kb.getModell().getTypDefinitionOrAttributgruppenDefinitionOrAspektDefinition!");
		
			for (Object o : _kb.getModell().getTypDefinitionOrAttributgruppenDefinitionOrAspektDefinition()) {
				if (o.getClass().equals(TypDefinition.class)) {
					
					mapTypDefinition.put(((TypDefinition) o).getPid(),((TypDefinition) o));
					
					List<Erweitert> listeErweitert = ((TypDefinition) o).getErweitert();
					for (Erweitert erweitert : listeErweitert) {
						mapErweitert.put(erweitert.getPid(),erweitert);
					}	
					List<Object> listeAttributgruppeOrMenge = ((TypDefinition) o).getAttributgruppeOrMenge();
					for (Object atgOrMenge : listeAttributgruppeOrMenge) {
						if (atgOrMenge.getClass().equals(Attributgruppe.class)) {
							mapAttributgruppe.put(((Attributgruppe) atgOrMenge).getPid(),((Attributgruppe) atgOrMenge));
						}
						else if (atgOrMenge.getClass().equals(Menge.class)) {
							mapMenge.put(((Menge) atgOrMenge).getPid(),((Menge) atgOrMenge));
						}
					}
				}
				else if (o.getClass().equals(AttributgruppenDefinition.class)) {
					mapAttributgruppenDefinition.put(((AttributgruppenDefinition) o).getPid(),((AttributgruppenDefinition) o));
					
					List<Aspekt> listeAspekt = ((AttributgruppenDefinition) o).getAspekt();
					for (Aspekt aspekt : listeAspekt) {
						mapAspekt.put(aspekt.getPid(),aspekt);
					}
					List<Object> listeAttribut = ((AttributgruppenDefinition) o).getAttributOrAttributlisteOrAttributauswahl();
					for (Object attribut : listeAttribut) {
						if (attribut.getClass().equals(Attribut.class)) {
							mapAttribut.put(((Attribut) attribut).getPid(),((Attribut) attribut));
						}
					}
					List<Object> listeAttributauswahl = ((AttributgruppenDefinition) o).getAttributOrAttributlisteOrAttributauswahl();
					for (Object attributauswahl : listeAttributauswahl) {
						if (attributauswahl.getClass().equals(Attributauswahl.class)) {
							mapAttributauswahl.put(((Attributauswahl) attributauswahl).getPid(),((Attributauswahl) attributauswahl));
						}
					}
					List<Object> listeAttributliste = ((AttributgruppenDefinition) o).getAttributOrAttributlisteOrAttributauswahl();
					for (Object attributliste : listeAttributliste) {
						if (attributliste.getClass().equals(Attributliste.class)) {
							mapAttributliste.put(((Attributliste) attributliste).getPid(),((Attributliste) attributliste));
						}
					}
				}
				else if (o.getClass().equals(AspektDefinition.class)) {
					mapAspektDefinition.put(((AspektDefinition) o).getPid(),((AspektDefinition) o));
				}
				else if (o.getClass().equals(MengenDefinition.class)) {
					mapMengenDefinition.put(((MengenDefinition) o).getPid(),((MengenDefinition) o));
					
					for(String elemente:((MengenDefinition) o).getElemente()){
						mapMengenElemente.put(elemente, elemente);
					}
				}
				else if (o.getClass().equals(AttributlistenDefinition.class)) {
					mapAttributlistenDefinition.put(((AttributlistenDefinition) o).getPid(),((AttributlistenDefinition) o));
					
					List<Object> listeAttribut = ((AttributlistenDefinition) o).getAttributOrAttributlisteOrAttributauswahl();
					for (Object attribut : listeAttribut) {
						if (attribut.getClass().equals(Attribut.class)) {
							mapAttribut.put(((Attribut) attribut).getPid(),((Attribut) attribut));
						}
					}
					List<Object> listeAttributauswahl = ((AttributlistenDefinition) o).getAttributOrAttributlisteOrAttributauswahl();
					for (Object attributauswahl : listeAttributauswahl) {
						if (attributauswahl.getClass().equals(Attributauswahl.class)) {
							mapAttributauswahl.put(((Attributauswahl) attributauswahl).getPid(),((Attributauswahl) attributauswahl));
						}
					}
					List<Object> listeAttributliste = ((AttributlistenDefinition) o).getAttributOrAttributlisteOrAttributauswahl();
					for (Object attributliste : listeAttributliste) {
						if (attributliste.getClass().equals(Attributliste.class)) {
							mapAttributliste.put(((Attributliste) attributliste).getPid(),((Attributliste) attributliste));
						}
					}
				}
				else if (o.getClass().equals(AttributDefinition.class)) {
					mapAttributDefinition.put(((AttributDefinition) o).getPid(),((AttributDefinition) o));
					ObjektReferenz obRef=((AttributDefinition) o).getObjektReferenz();
					if((obRef!=null)&&(obRef.getTyp()!=null)){
						mapObjektReferenz.put(obRef.getTyp(), obRef);
					}
					
				}
				else if (o.getClass().equals(AttributauswahlDefinition.class)) {
					mapAttributauswahlDefinition.put(((AttributauswahlDefinition) o).getPid(),((AttributauswahlDefinition) o));
					
					List<Auswahl> listeAuswahl = ((AttributauswahlDefinition) o).getAuswahl();
					for (Auswahl auswahl : listeAuswahl) {
						mapAuswahl.put(auswahl.getPid(),auswahl);
					}
				} else {
					Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, 
							"Keine Definitionen im Java-Objekt-Modell gefunden!",
							new NullPointerException()));
				}
			}
		}
		
		if (_kb.getObjekte() != null && _kb.getObjekte().getKonfigurationsObjekt() != null) {
			// System.out.println("kb.getObjekte().getKonfigurationsObjekt!");
			
		for (KonfigurationsObjekt ko : _kb.getObjekte().getKonfigurationsObjekt()) {
			if (ko.getClass().equals(KonfigurationsObjekt.class)) {
				mapKonfigurationsObjekt.put(((KonfigurationsObjekt) ko).getPid(),((KonfigurationsObjekt) ko));
				
				String typKO=((KonfigurationsObjekt) ko).getTyp();
				mapKonfigurationsObjektTyp.put(typKO, typKO);
				
				List<Object> listeDatensatzObjektMengeOrDefPar = ((KonfigurationsObjekt) ko).getDatensatzOrObjektMengeOrDefaultParameter();
				for (Object datensatzOrMengeOrDefPar : listeDatensatzObjektMengeOrDefPar) {
					if (datensatzOrMengeOrDefPar.getClass().equals(Datensatz.class)) {
						mapDatensatz.put(((Datensatz) datensatzOrMengeOrDefPar).getPid(),((Datensatz) datensatzOrMengeOrDefPar));
						String atg=((Datensatz) datensatzOrMengeOrDefPar).getAttributgruppe();
						String aspekt=((Datensatz) datensatzOrMengeOrDefPar).getAspekt();
						if(atg!=null){
							mapDatensatzAtg.put(atg, atg);
						}
						if(aspekt!=null){
							mapDatensatzAspekt.put(aspekt, aspekt);
						}
					}
					else if (datensatzOrMengeOrDefPar.getClass().equals(ObjektMenge.class)) {
						ObjektMenge om=(ObjektMenge)datensatzOrMengeOrDefPar;
						mapObjektMenge.put(om.getName(), om);
						for(Element element: om.getElement()){
							mapElement.put(element.getPid(), element);
						}
					}
					else if (datensatzOrMengeOrDefPar.getClass().equals(DefaultParameter.class)) {
						DefaultParameter defP=(DefaultParameter)datensatzOrMengeOrDefPar;
						mapKonfigurationsObjektDefParTyp.put(defP.getTyp(), defP.getTyp());
						mapKonfigurationsObjektDefParAtg.put(defP.getAttributgruppe(), defP.getAttributgruppe());
					}
				}
			} else {
				Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, 
						"Keine Definitionen im Java-Objekt-Modell gefunden!",
						new NullPointerException()));
			}
		}
		}
		
		// ENDE Java Objektstruktur
	}
	
	/**
	 * <p>Die Methode <code>xmlSchreiben</code></p>
	 * @param outDateinameXML
	 * @throws Exception
	 */
	public void xmlSchreiben (String outDateinameXML) throws Exception {
		
		_outDateinameXML = outDateinameXML;
		
		// System.out.format("--------------- JAXB (XML-Schreiben) inovat 2008 ---------------\n");
		
		// Einstiegs- und Factory-Klasse
		JAXBContext jc = JAXBContext.newInstance("de.inovat.sys.funclib.bsvrzxml.binder");
		
		// Serialisieren und Parsen
		Unmarshaller unmarshaller = jc.createUnmarshaller();
		Marshaller marshaller = jc.createMarshaller();
		// Validator validator = jc.createValidator();
		
		// ObjectFactory factory = new ObjectFactory();

		// Wert des encoding-Attributs in der XML-Deklaration
		// marshaller.setProperty(Marshaller.JAXB_ENCODING, Boolean.TRUE);
		
		// Die Ausgabe wird mit Linebreaks und Einrckungen formatiert
		marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

		// Wert des entsprechenden Attributs im Wurzelelement
		// marshaller.setProperty(Marshaller.JAXB_NO_NAMESPACE_SCHEMA_LOCATION, "K2S.xsd");
		
		// Wert des entsprechenden Attributs im Wurzelelement mit Namensraum
		marshaller.setProperty(Marshaller.JAXB_SCHEMA_LOCATION, "K2S.xsd");
		
		KonfigurationsBereich kb = (KonfigurationsBereich) unmarshaller.unmarshal(new FileInputStream(_inDateinameXML));

//		// marshaller.marshal(kb, System.out);
		marshaller.marshal(kb, new FileOutputStream(_outDateinameXML));
	}
	
	/**
	 * <p>Die Methode <code>htmlSchreiben</code></p>
	 * @param outDateinameHTML
	 * @throws Exception
	 
	public void htmlSchreiben (String outDateinameHTML) throws Exception {
		// System.out.format("--------------- JAXB (HTML-Schreiben) inovat 2008 ---------------\n");	
	}
	*/

	// ANFANG Getter

	/**
	 * @return mapAspekt
	 */
	public Map<String, Aspekt> getMapAspekt() {
		return mapAspekt;
	}
	
	/**
	 * @return mapAspektDefinition
	 */
	public Map<String, AspektDefinition> getMapAspektDefinition() {
		return mapAspektDefinition;
	}

	/**
	 * @return mapAttribut
	 */
	public Map<String, Attribut> getMapAttribut() {
		return mapAttribut;
	}

	/**
	 * @return mapAttributauswahl
	 */
	public Map<String, Attributauswahl> getMapAttributauswahl() {
		return mapAttributauswahl;
	}

	/**
	 * @return mapAttributauswahlDefinition
	 */
	public Map<String, AttributauswahlDefinition> getMapAttributauswahlDefinition() {
		return mapAttributauswahlDefinition;
	}

	/**
	 * @return mapAttributDefinition
	 */
	public Map<String, AttributDefinition> getMapAttributDefinition() {
		return mapAttributDefinition;
	}

	/**
	 * @return mapAttributgruppe
	 */
	public Map<String, Attributgruppe> getMapAttributgruppe() {
		return mapAttributgruppe;
	}

	/**
	 * @return mapAttributgruppenDefinition
	 */
	public Map<String, AttributgruppenDefinition> getMapAttributgruppenDefinition() {
		return mapAttributgruppenDefinition;
	}

	/**
	 * @return mapAttributliste
	 */
	public Map<String, Attributliste> getMapAttributliste() {
		return mapAttributliste;
	}

	/**
	 * @return mapAttributlistenDefinition
	 */
	public Map<String, AttributlistenDefinition> getMapAttributlistenDefinition() {
		return mapAttributlistenDefinition;
	}

	/**
	 * @return mapAuswahl
	 */
	public Map<String, Auswahl> getMapAuswahl() {
		return mapAuswahl;
	}

	/**
	 * @return mapDatensatz
	 */
	public Map<String, Datensatz> getMapDatensatz() {
		return mapDatensatz;
	}

	/**
	 * @return mapErweitert
	 */
	public Map<String, Erweitert> getMapErweitert() {
		return mapErweitert;
	}

	/**
	 * @return mapKonfigurationsBereich
	 */
	public Map<String, KonfigurationsBereich> getMapKonfigurationsBereich() {
		return mapKonfigurationsBereich;
	}

	/**
	 * @return mapKonfigurationsBereiche
	 */
	public Map<String, KonfigurationsBereiche> getMapKonfigurationsBereiche() {
		return mapKonfigurationsBereiche;
	}

	/**
	 * @return mapKonfigurationsDaten
	 */
	public Map<String, KonfigurationsDaten> getMapKonfigurationsDaten() {
		return mapKonfigurationsDaten;
	}

	/**
	 * @return mapKonfigurationsObjekt
	 */
	public Map<String, KonfigurationsObjekt> getMapKonfigurationsObjekt() {
		return mapKonfigurationsObjekt;
	}

	/**
	 * @return mapMenge
	 */
	public Map<String, Menge> getMapMenge() {
		return mapMenge;
	}

	/**
	 * @return mapMengenDefinition
	 */
	public Map<String, MengenDefinition> getMapMengenDefinition() {
		return mapMengenDefinition;
	}

	/**
	 * @return mapMethode
	 */
	public Map<String, Methode> getMapMethode() {
		return mapMethode;
	}

	/**
	 * @return mapModell
	 */
	public Map<String, Modell> getMapModell() {
		return mapModell;
	}

	/**
	 * @return mapObjekte
	 */
	public Map<String, Objekte> getMapObjekte() {
		return mapObjekte;
	}

	/**
	 * @return mapObjektMenge
	 */
	public Map<String, ObjektMenge> getMapObjektMenge() {
		return mapObjektMenge;
	}

	/**
	 * @return mapObjektReferenz
	 */
	public Map<String, ObjektReferenz> getMapObjektReferenz() {
		return mapObjektReferenz;
	}
	
	/**
	 * @return mapTypApplikation
	 */
	public Map<String, TypApplikation> getMapTypApplikation() {
		return mapTypApplikation;
	}

	/**
	 * @return mapTypDatenverteiler
	 */
	public Map<String, TypDatenverteiler> getMapTypDatenverteiler() {
		return mapTypDatenverteiler;
	}

	/**
	 * @return mapTypDefinition
	 */
	public Map<String, TypDefinition> getMapTypDefinition() {
		return mapTypDefinition;
	}

	/**
	 * @return mapTypProgramm
	 */
	public Map<String, TypProgramm> getMapTypProgramm() {
		return mapTypProgramm;
	}
	// ENDE Getter

	// ANFANG Setter

	/**
	 * @param mapAspekt mapAspekt 
	 */
	public void setMapAspekt(Map<String, Aspekt> mapAspekt) {
		this.mapAspekt = mapAspekt;
	}

	/**
	 * @param mapAspektDefinition mapAspektDefinition 
	 */
	public void setMapAspektDefinition(Map<String, AspektDefinition> mapAspektDefinition) {
		this.mapAspektDefinition = mapAspektDefinition;
	}

	/**
	 * @param mapAttribut mapAttribut 
	 */
	public void setMapAttribut(Map<String, Attribut> mapAttribut) {
		this.mapAttribut = mapAttribut;
	}

	/**
	 * @param mapAttributauswahl mapAttributauswahl 
	 */
	public void setMapAttributauswahl(Map<String, Attributauswahl> mapAttributauswahl) {
		this.mapAttributauswahl = mapAttributauswahl;
	}

	/**
	 * @param mapAttributauswahlDefinition mapAttributauswahlDefinition 
	 */
	public void setMapAttributauswahlDefinition(Map<String, AttributauswahlDefinition> mapAttributauswahlDefinition) {
		this.mapAttributauswahlDefinition = mapAttributauswahlDefinition;
	}

	/**
	 * @param mapAttributDefinition mapAttributDefinition 
	 */
	public void setMapAttributDefinition(Map<String, AttributDefinition> mapAttributDefinition) {
		this.mapAttributDefinition = mapAttributDefinition;
	}

	/**
	 * @param mapAttributgruppe mapAttributgruppe 
	 */
	public void setMapAttributgruppe(Map<String, Attributgruppe> mapAttributgruppe) {
		this.mapAttributgruppe = mapAttributgruppe;
	}

	/**
	 * @param mapAttributgruppenDefinition mapAttributgruppenDefinition 
	 */
	public void setMapAttributgruppenDefinition(Map<String, AttributgruppenDefinition> mapAttributgruppenDefinition) {
		this.mapAttributgruppenDefinition = mapAttributgruppenDefinition;
	}

	/**
	 * @param mapAttributliste mapAttributliste 
	 */
	public void setMapAttributliste(Map<String, Attributliste> mapAttributliste) {
		this.mapAttributliste = mapAttributliste;
	}

	/**
	 * @param mapAttributlistenDefinition mapAttributlistenDefinition 
	 */
	public void setMapAttributlistenDefinition(Map<String, AttributlistenDefinition> mapAttributlistenDefinition) {
		this.mapAttributlistenDefinition = mapAttributlistenDefinition;
	}

	/**
	 * @param mapAuswahl mapAuswahl 
	 */
	public void setMapAuswahl(Map<String, Auswahl> mapAuswahl) {
		this.mapAuswahl = mapAuswahl;
	}

	/**
	 * @param mapDatensatz mapDatensatz 
	 */
	public void setMapDatensatz(Map<String, Datensatz> mapDatensatz) {
		this.mapDatensatz = mapDatensatz;
	}

	/**
	 * @param mapErweitert mapErweitert 
	 */
	public void setMapErweitert(Map<String, Erweitert> mapErweitert) {
		this.mapErweitert = mapErweitert;
	}

	/**
	 * @param mapKonfigurationsBereich mapKonfigurationsBereich 
	 */
	public void setMapKonfigurationsBereich(Map<String, KonfigurationsBereich> mapKonfigurationsBereich) {
		this.mapKonfigurationsBereich = mapKonfigurationsBereich;
	}

	/**
	 * @param mapKonfigurationsBereiche mapKonfigurationsBereiche 
	 */
	public void setMapKonfigurationsBereiche(Map<String, KonfigurationsBereiche> mapKonfigurationsBereiche) {
		this.mapKonfigurationsBereiche = mapKonfigurationsBereiche;
	}

	/**
	 * @param mapKonfigurationsDaten mapKonfigurationsDaten 
	 */
	public void setMapKonfigurationsDaten(Map<String, KonfigurationsDaten> mapKonfigurationsDaten) {
		this.mapKonfigurationsDaten = mapKonfigurationsDaten;
	}

	/**
	 * @param mapKonfigurationsObjekt mapKonfigurationsObjekt 
	 */
	public void setMapKonfigurationsObjekt(Map<String, KonfigurationsObjekt> mapKonfigurationsObjekt) {
		this.mapKonfigurationsObjekt = mapKonfigurationsObjekt;
	}

	/**
	 * @param mapMenge mapMenge 
	 */
	public void setMapMenge(Map<String, Menge> mapMenge) {
		this.mapMenge = mapMenge;
	}

	/**
	 * @param mapMengenDefinition mapMengenDefinition 
	 */
	public void setMapMengenDefinition(Map<String, MengenDefinition> mapMengenDefinition) {
		this.mapMengenDefinition = mapMengenDefinition;
	}

	/**
	 * @param mapMethode mapMethode 
	 */
	public void setMapMethode(Map<String, Methode> mapMethode) {
		this.mapMethode = mapMethode;
	}

	/**
	 * @param mapModell mapModell 
	 */
	public void setMapModell(Map<String, Modell> mapModell) {
		this.mapModell = mapModell;
	}

	/**
	 * @param mapObjekte mapObjekte 
	 */
	public void setMapObjekte(Map<String, Objekte> mapObjekte) {
		this.mapObjekte = mapObjekte;
	}

	/**
	 * @param mapObjektMenge mapObjektMenge 
	 */
	public void setMapObjektMenge(Map<String, ObjektMenge> mapObjektMenge) {
		this.mapObjektMenge = mapObjektMenge;
	}

	/**
	 * @param mapObjektReferenz mapObjektReferenz 
	 */
	public void setMapObjektReferenz(Map<String, ObjektReferenz> mapObjektReferenz) {
		this.mapObjektReferenz = mapObjektReferenz;
	}

	/**
	 * @param mapTypApplikation mapTypApplikation 
	 */
	public void setMapTypApplikation(Map<String, TypApplikation> mapTypApplikation) {
		this.mapTypApplikation = mapTypApplikation;
	}

	/**
	 * @param mapTypDatenverteiler mapTypDatenverteiler 
	 */
	public void setMapTypDatenverteiler(Map<String, TypDatenverteiler> mapTypDatenverteiler) {
		this.mapTypDatenverteiler = mapTypDatenverteiler;
	}

	/**
	 * @param mapTypDefinition mapTypDefinition 
	 */
	public void setMapTypDefinition(Map<String, TypDefinition> mapTypDefinition) {
		this.mapTypDefinition = mapTypDefinition;
	}

	/**
	 * @param mapTypProgramm mapTypProgramm 
	 */
	public void setMapTypProgramm(Map<String, TypProgramm> mapTypProgramm) {
		this.mapTypProgramm = mapTypProgramm;
	}
	
	// ENDE Setter
	
	//*******************************************************************************
	
	public KonfigurationsBereich getKb() {
		return _kb;
	}
	
	public void setKb(KonfigurationsBereich kb) {
		_kb = kb;
	}

	/**
	 * @return mapMengenElemente
	 */
	public Map<String, String> getMapMengenElemente() {
		return mapMengenElemente;
	}

	/**
	 * @param mapMengenElemente mapMengenElemente 
	 */
	public void setMapMengenElemente(Map<String, String> mapMengenElemente) {
		this.mapMengenElemente = mapMengenElemente;
	}

	/**
	 * @return mapDatensatzAtg
	 */
	public Map<String, String> getMapDatensatzAtg() {
		return mapDatensatzAtg;
	}

	/**
	 * @param mapDatensatzAtg mapDatensatzAtg 
	 */
	public void setMapDatensatzAtg(Map<String, String> mapDatensatzAtg) {
		this.mapDatensatzAtg = mapDatensatzAtg;
	}

	/**
	 * @return mapDatensatzAspekt
	 */
	public Map<String, String> getMapDatensatzAspekt() {
		return mapDatensatzAspekt;
	}

	/**
	 * @param mapDatensatzAspekt mapDatensatzAspekt 
	 */
	public void setMapDatensatzAspekt(Map<String, String> mapDatensatzAspekt) {
		this.mapDatensatzAspekt = mapDatensatzAspekt;
	}

	/**
	 * @return mapElement
	 */
	public Map<String, Element> getMapElement() {
		return mapElement;
	}

	/**
	 * @param mapElement mapElement 
	 */
	public void setMapElement(Map<String, Element> mapElement) {
		this.mapElement = mapElement;
	}

	/**
	 * Getter fr Eigenschaft 'mapKonfigurationsObjektTyp'.
	 * 
	 * @return Wert der Eigenschaft 'mapKonfigurationsObjektTyp'.
	 * 
	 * @see  {#link mapKonfigurationsObjektTyp}
	 */
	public Map<String, String> getMapKonfigurationsObjektTyp() {
		return mapKonfigurationsObjektTyp;
	}

	/**
	 * Getter fr Eigenschaft 'mapKonfigurationsObjektDefParTyp'.
	 * 
	 * @return Wert der Eigenschaft 'mapKonfigurationsObjektDefParTyp'.
	 * 
	 * @see  {#link mapKonfigurationsObjektDefParTyp}
	 */
	public Map<String, String> getMapKonfigurationsObjektDefParTyp() {
		return mapKonfigurationsObjektDefParTyp;
	}

	/**
	 * Getter fr Eigenschaft 'mapKonfigurationsObjektDefParAtg'.
	 * 
	 * @return Wert der Eigenschaft 'mapKonfigurationsObjektDefParAtg'.
	 * 
	 * @see  {#link mapKonfigurationsObjektDefParAtg}
	 */
	public Map<String, String> getMapKonfigurationsObjektDefParAtg() {
		return mapKonfigurationsObjektDefParAtg;
	}

	//*******************************************************************************
	
	

}

