/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.projektlib.speicher;

import de.inovat.buv.projektlib.Activator;

//~ NICHT JDK IMPORTE =========================================================


//~ KLASSEN ===================================================================

/**
 * Klasse enthlt die EINDEUTIGEN Parameter fr die Speicherfunktionen.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 22 $ / $Date: 2013-09-24 15:51:26 +0200 (Di, 24 Sep 2013) $ / ($Author: LG $)
 */
public class SpeicherParameter {

    /** ID von diesem PlugIn. Wird als Startstring fr alle ParameterIDs benutzt. */
    public final static String AKTIVATOR_ID = Activator.PLUGIN_ID + ".";

    /** ID des Parameters fr den BenutzerOrner. */
    public final static String BENUTZER_ORDNER = AKTIVATOR_ID + "benutzerOrdner";
    
}


//~Formatiert mit 'inovat Kodierkonvention' am 30.07.10
